import * as React from 'react';
import { IPageAPI } from 'src/app/global-api';
export declare const widgetKeys: string[];
export declare const WIDGET_API_MAP: {};
export declare const WidgetsContext: React.Context<{
    parent: any;
}>;
export declare function checkVisible({ id, _visible }: {
    id: any;
    _visible?: any;
}): boolean;
interface MPNodesRefFields {
    id?: HTMLElement['id'];
    dataset?: HTMLElement['dataset'];
    left?: DOMRect['left'];
    right?: DOMRect['right'];
    top?: DOMRect['top'];
    bottom?: DOMRect['bottom'];
    width?: DOMRect['width'];
    height?: DOMRect['height'];
    scrollLeft?: HTMLElement['scrollLeft'];
    scrollTop?: HTMLElement['scrollTop'];
    [prop: string]: string | any;
}
export declare function getDom(element: HTMLElement, options: any): Promise<MPNodesRefFields>;
export declare function findWidgets(widget: any, parentType: any, filterFn: any, includeInvisibleDescendants: any): any;
export declare function retryDataBinds(tryTime?: number): void;
export declare function createWidgets(ctx: {
    /**
     * 为了之后和组件生成复用
     * 值为 $page 或 $comp
     */
    apiContext: IPageAPI;
    widgets?: any;
    widgetProps?: any;
    nodeMap?: any;
}, widgetProps: any, dataBinds: any, controledDataContext: any): {
    widgets: {
        _disposers: any[];
    } | import("mobx").IReactionDisposer;
    nodeMap: Record<string, IWidgetNode>;
};
/**
 * Add parent, children to widget
 */
interface IWidgetNode {
    id: string;
    value: any;
    children: IWidgetNode[];
    parent: null | IWidgetNode;
    forCount: number;
    exist: boolean;
    changed: string[];
}
export declare function generateWidgetAPIContext($w: {}, widget: any, forContext: any): {};
export {};
